# Joomla

Joomla CMS.

Make sure the projectName is set correctly, it's very important, because it's used for git, docker, mysql and joomla.

## Quick Installation

```bash
# STEP 1
# Clone the repo (change projectName to the name of your project)
git clone git@git.nickyeoman.com:nick/joomla.git projectName

# STEP 2
# Move into the dir
cd projectName

# STEP 3
# Setup your env file
mv env.sample .env
vi .env

# STEP 4
# Prepare your project for git 
bash bin/new_project.sh

# STEP 5
# Run the containers to initialize 
sudo bash bin/docker_up.sh

# STEP 6
# Joomla cli installer 
sudo bash bin/setup_joomla_installer.sh

# STEP 7
# Manually set Site Meta Description in [Administrator](http://localhost:8000/administrator/index.php?option=com_config)

# Step 8
# Clean up and Config
sudo bash bin/finalize.sh

```

## Development Environment

Let's update our bash_profile with some alias:
```bash
alias joomla='docker-compose exec -u www-data joomla php cli/joomla.php'
```
Allowing you to just run commands like this: 
```bash
joomla core:check-updates
joomla site:down
joomla extension:list
joomla update:extensions:check
joomla cache:clean

```

## Create A Component

1. Move to the directory where you would like to keep the component. ```cd ~/joomla-components/```
1. Run component creator from your Joomla install. ```bash ~/projects/joomla/projectName/bin/create_component.sh```
1. Optionally save to git repo.
1. build the zip file by running bin/build_component.sh

## References

* [Joomla Twig](https://phproberto.github.io/joomla-twig/)

### Component

* https://github.com/ceford/j4xdemos-com-mywalks/tree/master
* https://www.abdulwaheed.pk/en/blog/41-information-technology/44-joomla/302-how-to-create-joomla-4-component.html
* Can't get this one working either: https://www.techfry.com/resources/how-to-create-joomla-component
* https://docs.joomla.org/J4.x:Developing_an_MVC_Component/Introduction
  * Can't get this one working [Develop a component](https://docs.joomla.org/J4.x:Developing_an_MVC_Component/Developing_a_Basic_Component)
* [Minimal component](https://joomla.stackexchange.com/questions/22176/minimal-basic-structure-for-a-frontend-joomla-component-without-using-joomla-mvc)